unit tcMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeTools, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

const
  MAXVALUE = 10000;

type
  TForm1 = class(TForm)
    Chart: TChart;
    CursorTool: TCursorTool;
    Timer1: TTimer;
    Series2: TBarSeries;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ChartAfterDraw(Sender: TObject);
  private
    FValue1 : Integer;
    FValue2 : Integer;
    FBuffer : TBitmap;
    IsBuffering : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  DateUtils;

procedure TForm1.ChartAfterDraw(Sender: TObject);
begin
  If (NOT IsBuffering)
   Then Begin
        IsBuffering := True;
        FBuffer.Width := Chart.Width;
        FBuffer.Height := Chart.Height;
        Chart.Draw(FBuffer.Canvas,FBuffer.Canvas.ClipRect);
        End
   Else Isbuffering := False;
end;

procedure TForm1.FormShow(Sender: TObject);
var
 i : integer;
begin
  for i := 1 to MAXVALUE do
    Series2.AddXY(i, Random(100));

  FValue1 := 0;
  FValue2 := 0;
  IsBuffering := False;
  FBuffer := TBitmap.Create;

  with Chart do
  begin
    ClipPoints := False;
    Title.Visible := False;
    Legend.Visible := False;
    LeftAxis.Axis.Width:=1;
    BottomAxis.Axis.Width:=1;
    BottomAxis.RoundFirstLabel := False;
    View3D := False;
  end;

  Chart.Axes.FastCalc := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var XPos : Integer;
begin
  if (ComboBox1.ItemIndex = 0) then
  begin
    Inc(FValue1);
    CursorTool.XValue := FValue1;
  end
  else
  begin
    Inc(FValue2);
    XPos:=Chart.Series[0].CalcXPos(FValue2);
    With (Chart.Canvas) Do
    Begin
      Chart.Canvas.Draw(0,0,FBuffer);
      Pen.Color := CursorTool.Pen.Color;
      Pen.Style:=CursorTool.Pen.Style;
      MoveTo(XPos,Chart.ChartRect.Top);
      LineTo(XPos,Chart.ChartRect.Bottom);
   End;
  end;
end;

end.
